Count The Pairs(hdu-4750)(最小生成树)

本文介绍了一种利用最小生成树解决特定图论问题的方法,该问题涉及寻找多个点间路径上的最大边权值,并统计满足特定条件的点对数量。

摘要生成于 C知道 ,由 DeepSeek-R1 满血版支持, 前往体验 >



Count The Pairs

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 1454    Accepted Submission(s): 651


Problem Description

  With the 60th anniversary celebration of Nanjing University of Science and Technology coming soon, the university sets n tourist spots to welcome guests. Of course, Redwood forests in our university and its Orychophragmus violaceus must be recommended as top ten tourist spots, probably the best of all. Some undirected roads are made to connect pairs of tourist spots. For example, from Redwood forests (suppose it’s a) to fountain plaza (suppose it’s b), there may exist an undirected road with its length c. By the way, there is m roads totally here. Accidently, these roads’ length is an integer, and all of them are different. Some of these spots can reach directly or indirectly to some other spots. For guests, they are travelling from tourist spot s to tourist spot t, they can achieve some value f. According to the statistics calculated and recorded by us in last years, We found a strange way to calculate the value f:
  From s to t, there may exist lots of different paths, guests will try every one of them. One particular path is consisted of some undirected roads. When they are travelling in this path, they will try to remember the value of longest road in this path. In the end, guests will remember too many longest roads’ value, so he cannot catch them all. But, one thing which guests will keep it in mind is that the minimal number of all these longest values. And value f is exactly the same with the minimal number.
  Tom200 will recommend pairs (s, t) (start spot, end spot points pair) to guests. P guests will come to visit our university, and every one of them has a requirement for value f, satisfying f>=t. Tom200 needs your help. For each requirement, how many pairs (s, t) you can offer?
 

Input
  Multiple cases, end with EOF.
  First line:n m
  n tourist spots ( 1<n<=10000), spots’ index starts from 0.
  m undirected roads ( 1<m<=500000).

  Next m lines, 3 integers, a b c
  From tourist spot a to tourist spot b, its length is c. 0<a, b<n, c(0<c<1000000000), all c are different.

  Next one line, 1 integer, p (0<p<=100000)
  It means p guests coming.

  Next p line, each line one integer, t(0<=t)
  The value t you need to consider to satisfy f>=t.
 

Output
  For each guest's requirement value t, output the number of pairs satisfying f>=t.
  Notice, (1,2), (2,1) are different pairs.
 

Sample Input
      
      
2 1 0 1 2 3 1 2 3 3 3 0 1 2 0 2 4 1 2 5 5 0 2 3 4 5
 

Sample Output
      
      
2 2 0 6 6 4 4 0
 

Source

题意理解:就是有两个点,他们会有很多条路径可以到达,我要找的是每条线路里最长的一条边,里面最小的。这个就会作为两个点之间的值,然后会输入一些询问值,就是问有多少对点之间的值,大于等于这个要询问的值。

解题思路:这一开始真的毫无头绪,别人给我说这是最小生成树的时候,我也是一脸懵逼,根本不知道怎么和最小生成树联系上,想了很久,终于想通了。最小生成树的算法就是从最小的权值开始,逐渐连成一棵树,当出现两个集需要连成一个集合时,那个连接的边,就是这两个集合的点与点之间的值,就是我们需要比较的值,因为他一定是,目前两边的点相连必经的边,那么也就是最大边,无论怎样两边点的最大边都是这条边。那么也就是最大里最小的了。

#include<stdio.h>
#include<algorithm>
#include<map>
#include<string.h>
using namespace std;
struct s{
    int u;
    int v;
    int val;
}a[500010];
int pre[10100];
int num[10010];
int find_(int x)  //并查集
{
    int r=x;
    while(pre[r]!=r)
    {
        r=pre[r];
    }
    int t=x,y;
    while(pre[t]!=r)   //路径压缩
    {
        y=pre[t];
        pre[t]=r;
        t=y;
    }
    return r;
}
int cmp(s x,s y)
{
    return x.val<y.val;
}
long long sum[10100];
int  oo[10100];
int main()
{
    int n,m;
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        memset(a,0,sizeof(a));
        for(int i=0;i<=n;i++)
        {
            pre[i]=i;
            num[i]=1;
        }
        for(int i=0;i<m;i++)
        {
            scanf("%d%d%d",&a[i].u,&a[i].v,&a[i].val);
        }
        sort(a,a+m,cmp);
        int len=0;
        for(int i=0;i<m;i++)
        {
             int y1=find_(a[i].u);
             int y2=find_(a[i].v);
             if(y1!=y2)
             {
                 pre[y1]=y2;
                 sum[len]=(long long )num[y1]*num[y2]*2;  //把当前两个集合的元素乘起来,就是有多少条路径都是这条边相连
                 oo[len]=a[i].val;
                 len++;
                 num[y2]=num[y1]+num[y2];  
             }
        }
        for(int i=1;i<len;i++)
        {
            sum[i]+=sum[i-1];    //将刚才所求累加起来
        }
        int q;
        scanf("%d",&q);
        for(int i=0;i<q;i++)
        {
            int p;
            scanf("%d",&p);
            int x=lower_bound(oo,oo+len,p)-oo-1;  //二分求到第一个大于等于p的在数组里的位置
            printf("%I64d\n",sum[len-1]-sum[x]);
        }
    }
}

校园失物招领微信小程序源码, 失物招领小程序主要为解决大学生时常丢失物品而且很难找回以及归还过程繁琐不方便的问题, 与传统的失物招领方式不同,该款校园失误招领小程序拥有快捷发布寻物启事和失误找领功能, 快速查找、极速归还、高效沟通、防误领冒领等功能, 在开发校园失物招领小程序前与用户访谈发现有近40的同学校园内频繁丢失物品、证件、校园卡等, 数码产品、日用品等,丢失区域主要发生在教学楼、图书馆和食堂。 拾领校园失物招领小程序继承了寻物启事和失物招领,丢失物品或拾取物品都可发布帖子, 首页的横幅滚动公告展示通知公告等,banner图片化的方式更具有视觉吸引力, 最新信息可显示最近发布的招领信息或寻物信息,更加方便快捷的展示信息, 用户可通过首页的发布按钮发布帖子,发布者只需填写物品的相关信息,类别、地点等相关信息, 并且可以填写手机号开启认领验证,并可以一键生成二维码分享或分享至群聊和朋友圈。 列表内可以筛选物品类别或精确搜索,物品详情里可展示物品的相关信息, 确认是自己的物品后可点击认领,然后验证信息,需填写物品的关键信息以作辨认, 防止冒领误领,物品详情页可生成二维码海报分享,还有即时的消息联系功能以提高沟通效率, 发布者还可选择放置在代收处,双方还可以通过拨打电话紧急联系,用于紧急情况,让失物找到主人, 个人中心可以管理发布的物品帖子,管理个人信息,包括昵称、默认学校、手机号的修改、 编辑发布的物品帖子、获取帮助等。帮助用户流畅的使用该小程序。
### 最小生成树与最短路径的区别 #### 定义差异 最小生成树(MST)是指在一个给定的加权连通无向图中找到一棵总权重最小的生成树。对于有n个顶点的图来说,MST会恰好包含n-1条,并连接所有的节点而不会形成任何环路[^1]。 相比之下,最短路径问题旨在寻找两个特定节点间的具有最低累积成本的一条或多条路径。当讨论单源最短路径时,则是从单一起点出发到其他所有可达结点之间的最短距离;如果是全对最短路径(all-pairs),则涉及计算每一对不同节点间可能存在的最优路线[^2]。 #### 应用场景的不同 由于两者解决的问题本质上的差别,在实际应用上也有所区分: - **网络设计**:比如构建通信网络或电力传输线路时通常考虑的是如何以最少的成本覆盖整个区域内的站点,这时就会采用MST来规划最佳方案。 - **路由选择**:而在互联网数据包转发、城市交通导航等领域内更关注于两点之间怎样走才能最快到达目的地,因此倾向于运用像Dijkstra这样的SP算法来进行决策支持。 #### 算法复杂度对比 关于时间效率方面,Prim's algorithm用于求解MST的时间复杂度可以达到O(E+VlogV),其中E代表的数量,V表示顶点数。而对于处理稀疏图的情况,Tarjan改进后的Chu-Liu/Edmonds算法同样能够提供相近性能表现。至于针对最短路径问题的经典解决方案——Dijkstra算法,在相同条件下其平均情况下的渐近界也是相似水平即O((E+V)log V)。 ```python import heapq def dijkstra(graph, start): pq = [(0, start)] dist = {start: 0} while pq: d, u = heapq.heappop(pq) if d != dist.get(u,float('inf')): continue for v,w in graph[u].items(): alt = dist[u]+w if alt<dist.get(v,float('inf')): dist[v]=alt heapq.heappush(pq,(alt,v)) return dist from collections import defaultdict class Graph(): def __init__(self): self.graph=defaultdict(list) def addEdge(self,u,v,w): self.graph[u].append([v,w]) def primMST(self): key=[float("Inf")]*len(self.graph) parent=[None]*len(self.graph) mstSet=[False]*(max(self.graph)+1) key[0]=0 parent[0]=-1 for cout in range(len(self.graph)): u=self.minKey(key,mstSet) mstSet[u]=True for i in range(len(self.graph)): try : w=self.graph[u][i][1] if mstSet[i]==False and w>0 and key[i]>w : key[i]=w parent[i]=u except IndexError: pass result=[] for node in range(1,len(parent)) : result.append([parent[node],node,key[node]]) return result def minKey(self,key,mstSet): min=float("Inf") min_index=-1 for v in range(max(self.graph)+1): if key[v]<min and mstSet[v]==False: min=key[v] min_index=v return min_index ```
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值